"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _utils = _interopRequireDefault(require("../utils"));
var _dataQueryBuilder = _interopRequireWildcard(require("./data-query-builder"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var GroupQueryBuilder = /*#__PURE__*/function (_DataQueryBuilder) {
  (0, _inherits2["default"])(GroupQueryBuilder, _DataQueryBuilder);
  var _super = _createSuper(GroupQueryBuilder);
  function GroupQueryBuilder() {
    var _this;
    (0, _classCallCheck2["default"])(this, GroupQueryBuilder);
    _this = _super.call(this);
    _this.groupPageSize = _dataQueryBuilder.PAGING_DEFAULTS.pageSize;
    _this.recordsPageSize = _dataQueryBuilder.PAGING_DEFAULTS.pageSize;
    _this.groupDepth = null;
    _this.groupPath = null;
    return _this;
  }
  (0, _createClass2["default"])(GroupQueryBuilder, [{
    key: "setGroupPageSize",
    value: function setGroupPageSize(groupPageSize) {
      if (groupPageSize <= 0) {
        throw new Error('Group page size must be a positive value.');
      }
      this.groupPageSize = groupPageSize;
      return this;
    }
  }, {
    key: "getGroupPageSize",
    value: function getGroupPageSize() {
      return this.groupPageSize;
    }
  }, {
    key: "setRecordsPageSize",
    value: function setRecordsPageSize(recordsPageSize) {
      if (recordsPageSize <= 0) {
        throw new Error('Records page size must be a positive value.');
      }
      this.recordsPageSize = recordsPageSize;
      return this;
    }
  }, {
    key: "getRecordsPageSize",
    value: function getRecordsPageSize() {
      return this.recordsPageSize;
    }
  }, {
    key: "setGroupDepth",
    value: function setGroupDepth(groupDepth) {
      if (groupDepth < 0) {
        throw new Error('Group depth cannot have a negative value.');
      }
      this.groupDepth = groupDepth;
      return this;
    }
  }, {
    key: "getGroupDepth",
    value: function getGroupDepth() {
      return this.groupDepth;
    }
  }, {
    key: "getGroupPath",
    value: function getGroupPath() {
      return this.groupPath;
    }
  }, {
    key: "addGroupPath",
    value: function addGroupPath(groupPath) {
      this.groupPath = (this.groupPath || []).concat(groupPath);
      return this;
    }
  }, {
    key: "setGroupPath",
    value: function setGroupPath(groupPath) {
      this.groupPath = _utils["default"].castArray(groupPath);
      return this;
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      var result = (0, _get2["default"])((0, _getPrototypeOf2["default"])(GroupQueryBuilder.prototype), "toJSON", this).call(this);
      result.groupDepth = this.getGroupDepth();
      result.groupPath = this.getGroupPath();
      result.groupPageSize = this.getGroupPageSize();
      result.recordsPageSize = this.getRecordsPageSize();
      return result;
    }
  }]);
  return GroupQueryBuilder;
}(_dataQueryBuilder["default"]);
exports["default"] = GroupQueryBuilder;