"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deprecated = void 0;
var deprecated = function deprecated(namespace, alternative) {
  return function (target, prop, descriptor) {
    var value = target[prop];
    descriptor.initializer = function () {
      return function () {
        var mainMessage = "\"".concat(namespace, ".").concat(prop, "\" is deprecated and will be removed in the nearest release.");
        var helpMessage = " Please use ".concat(alternative, ".");

        // eslint-disable-next-line no-console
        console.warn("".concat(mainMessage).concat(alternative ? helpMessage : ''));
        return value.apply(this, arguments);
      };
    };
    return descriptor;
  };
};
exports.deprecated = deprecated;