"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.RTScopeConnector = exports.RTListeners = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _backendlessRequest = _interopRequireDefault(require("backendless-request"));
var _backendlessRtClient = _interopRequireDefault(require("backendless-rt-client"));
var _utils = _interopRequireDefault(require("./utils"));
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var RTListeners = _backendlessRtClient["default"].Listeners;
exports.RTListeners = RTListeners;
var RTScopeConnector = _backendlessRtClient["default"].ScopeConnector;
exports.RTScopeConnector = RTScopeConnector;
function loadAppInfo(appPath) {
  return _backendlessRequest["default"].get("".concat(appPath, "/info"));
}
var RT = /*#__PURE__*/function (_BackendlessRTClient) {
  (0, _inherits2["default"])(RT, _BackendlessRTClient);
  var _super = _createSuper(RT);
  function RT(app) {
    var _this;
    (0, _classCallCheck2["default"])(this, RT);
    var appId = app.appId,
      apiKey = app.apiKey,
      appPath = app.appPath,
      debugMode = app.debugMode;
    var clientId = _utils["default"].uuid();
    var lookupPath = "".concat(appPath, "/rt/lookup");
    _this = _super.call(this, {
      appId: appId || undefined,
      lookupPath: lookupPath,
      debugMode: debugMode,
      connectQuery: function connectQuery() {
        var userToken = app.getCurrentUserToken();
        return {
          apiKey: apiKey || undefined,
          clientId: clientId,
          userToken: userToken
        };
      },
      socketConfigTransform: function () {
        var _socketConfigTransform = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(socketConfig) {
          var appInfo;
          return _regenerator["default"].wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                if (appId) {
                  _context.next = 7;
                  break;
                }
                _context.next = 3;
                return loadAppInfo(appPath);
              case 3:
                appInfo = _context.sent;
                socketConfig.url = "".concat(socketConfig.host, "/").concat(appInfo.appId);
                socketConfig.options.path = "/".concat(appInfo.appId);
                socketConfig.options.query.apiKey = appInfo.apiKey;
              case 7:
                return _context.abrupt("return", socketConfig);
              case 8:
              case "end":
                return _context.stop();
            }
          }, _callee);
        }));
        function socketConfigTransform(_x) {
          return _socketConfigTransform.apply(this, arguments);
        }
        return socketConfigTransform;
      }()
    });
    _this.app = app;
    return _this;
  }
  (0, _createClass2["default"])(RT, [{
    key: "updateUserTokenIfNeeded",
    value: function updateUserTokenIfNeeded() {
      if (this.session) {
        var userToken = this.app.getCurrentUserToken();
        this.methods.setUserToken({
          userToken: userToken
        });
      }
    }
  }, {
    key: "setDebugMode",
    value: function setDebugMode(debugMode) {
      this.setConfig({
        debugMode: debugMode
      });
    }
  }]);
  return RT;
}(_backendlessRtClient["default"]);
exports["default"] = RT;